<template lang="html">
  <label class="butter-checkbox" :class="{ checked: internal }" @click.prevent="toggleInternal">
    <input type="checkbox" :checked="value" v-bind="$attrs" @input="onInput" @click="onInput" :name="name" />
    <svg width="24" height="24" view-box="0 0 24 24" fill="none">
      <path class="unchecked" fill-rule="evenodd" clip-rule="evenodd"
      d="M4 2C2.89543 2 2 2.89543 2 4V20C2 21.1046 2.89543 22 4 22H20C21.1046 22 22 21.1046 22 20V4C22 2.89543 21.1046 2 20 2H4ZM5 4C4.44772 4 4 4.44772 4 5V19C4 19.5523 4.44772 20 5 20H19C19.5523 20 20 19.5523 20 19V5C20 4.44772 19.5523 4 19 4H5Z" 
      fill="white" fill-opacity="0.75"/>
      <rect class="checked" x="4" y="4" width="16" height="16" fill="#5B6DEE"/>
      <path class="checked" fill-rule="evenodd" clip-rule="evenodd" d="M4 2C2.89543 2 2 2.89543 2 4V20C2 21.1046 2.89543 22 4 22H20C21.1046 22 22 21.1046 22 20V4C22 2.89543 21.1046 2 20 2H4ZM5 4C4.44772 4 4 4.44772 4 5V19C4 19.5523 4.44772 20 5 20H19C19.5523 20 20 19.5523 20 19V5C20 4.44772 19.5523 4 19 4H5Z" fill="#5B6DEE"/>
      <path class="checked" d="M8.70711 11.2929C8.31658 10.9024 7.68342 10.9024 7.29289 11.2929C6.90237 11.6834 6.90237 12.3166 7.29289 12.7071L8.70711 11.2929ZM11 15L10.2929 15.7071C10.4916 15.9058 10.7646 16.0117 11.0453 15.999C11.326 15.9862 11.5884 15.856 11.7682 15.6402L11 15ZM16.7682 9.64018C17.1218 9.21591 17.0645 8.58534 16.6402 8.23178C16.2159 7.87821 15.5853 7.93554 15.2318 8.35982L16.7682 9.64018ZM7.29289 12.7071L10.2929 15.7071L11.7071 14.2929L8.70711 11.2929L7.29289 12.7071ZM11.7682 15.6402L16.7682 9.64018L15.2318 8.35982L10.2318 14.3598L11.7682 15.6402Z" fill="white"/>
    </svg>
    <slot v-if="$slots.default"></slot>
    <a v-else-if="link" @click="$emit('browser-url', link)">{{ label }}</a>
    <span v-else v-html="label" @click.prevent.stop="captureBrowserUrl"></span>
  </label>
</template>

<style lang="scss" scoped>

@import "butter-mixins";

label.butter-checkbox {
  display: flex;
  align-items: center;
  padding: 0 $grid;
  margin-bottom: $grid;
  
  input[type="checkbox"] {
    display: none;
    
    + svg {
      display: flex;
      flex-shrink: 0;
      padding: $grid;
    }
    
    + svg .checked {
      transition: opacity 100ms linear;
      opacity: 0;
    }
  }
  
  &.checked input[type="checkbox"] + svg .checked {
    opacity: 100;
  }
}

a, span {
  padding-left: $grid;
}
</style>
<script>
import { EVENT_INPUT } from '../lib/events';

export default {
  props: ['value','link','label','name'],
  data() {
    return {
      internal: this.value || false,
    };
  },
  methods: {
    onInput(event) {
      this.$emit(EVENT_INPUT, String(event.target.checked));
    },
    captureBrowserUrl(event) {
      const url = event.target && event.target.href;
      if (url) this.$emit('browser-url', { url });
      if (!url) {
        this.toggleInternal();
      }
    },
    toggleInternal() {
      this.internal = !this.internal;
      this.$emit(EVENT_INPUT, String(this.internal));
    }
  },
  inheritAttrs: false,
}
  
</script>
